POJ3126 Prime Path 打表+BFS

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. — It is a matter of security to change such things every now and then, to keep the enemy in the dark. — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. — Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you? — In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 1033 1733 3733 3739 3779 8779 8179 The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3 1033 8179 1373 8017 1033 1033

Sample Output

6 7 0

题目描述

给两个四位数a,b 每次改变a中的一位而且改动之后的必须是素数,问最少改动几次可以到b?(永远达不到b就输出impossible)

解题思路

先打一个素数表,,然后用queue模拟搜索过程,将搜索的深度放入结构体中,可以更好地输出改动次数。

代码;const int maxn = 10010;bool prime[maxn];bool vis[maxn];bool isfind;int cnt;struct num {int c;int floor;};queue<num> que;num a,b;void bfs(void){//1033 8179//que:2033 3033 …0033 1133 1233…1933 1043 1053 … 1023 1034 … 1032que.push(a);while(!que.empty()) {//p = 1033num p = que.front();que.pop();if(p.c <= 1000 || !prime[p.c] || vis[p.c]) continue;vis[p.c] = true;if(p.c == b.c) {isfind = true;cnt = p.floor;return;}for(int i = 1 ; i < 10 ; i ++) {num tmp;tmp.c = (p.c+1000*i)%10000;tmp.floor = p.floor + 1;que.push(tmp);tmp.c = (p.c/1000)*1000+(p.c%1000+100*i)%1000;que.push(tmp);tmp.c = (p.c/100)*100+(p.c%100+10*i)%100;que.push(tmp);tmp.c = (p.c/10)*10+(p.c%10+i)%10;que.push(tmp);}}}int main(){prime[0] = prime[1] = false;for(int i = 2 ; i < maxn ; i ++) prime[i] = true;for(int i = 2 ; i*i <= maxn ; i ++) {if(!prime[i]) continue;for(int j = i*2 ; j < maxn ; j += i) {prime[j] = false;}}int t;scanf(“%d”,&t);while(t–) {//初始化cnt = 0;isfind = false;while(!que.empty()) que.pop();memset(vis,false,sizeof(vis));scanf(“%d%d”,&a.c,&b.c);if(a.c == b.c) {printf(“0\n”);continue;}bfs();if(isfind) printf(“%d\n”,cnt);else printf(“Impossible\n”);}return 0;}

你曾经说,你曾经说。走在爱的旅途,我们的脚步多么轻松……

POJ3126 Prime Path 打表+BFS

相关文章:

你感兴趣的文章:

标签云: